import { Injectable } from '@angular/core';

@Injectable({
  providedIn: 'root',
})
export class TaskService {
  constructor() {}

  public toggleTaskDoneStatus(task: Task): Promise<Task> {
    return new Promise((resolve, reject) => {
      fetch('http://localhost:2000/api/tasks/' + task.id, {
        method: 'PUT',
        body: JSON.stringify({
          ...task,
          done: !task.done,
        }),
        headers: {
          'content-type': 'application/json',
        },
      }).then((response) => {
        if (response.status != 200) {
          reject('Error toggling task done status');
        } else {
          response.json().then((json) => resolve(json));
        }
      });
    });
  }

  public deleteTask(task: Task): Promise<void> {
    return new Promise((resolve, reject) => {
      fetch('http://localhost:2000/api/tasks/' + task.id, {
        method: 'DELETE',
      }).then((response) => {
        if (response.status != 200) {
          reject('Error deleting task');
        } else {
          resolve();
        }
      });
    });
  }

  public createTask(task: Task): Promise<Task> {
    return new Promise((resolve, reject) => {
      fetch('http://localhost:2000/api/tasks', {
        method: 'POST',
        body: JSON.stringify(task),
        headers: {
          'content-type': 'application/json',
        },
      }).then((response) => {
        if (response.status != 200) {
          reject('Request did not create tasks succesfully');
        } else {
          response.json().then((json) => resolve(json));
        }
      });
    });
  }

  public updateTask(task: Task): Promise<Task> {
    return new Promise((resolve, reject) => {
      fetch('http://localhost:2000/api/tasks/' + task.id, {
        method: 'PUT',
        body: JSON.stringify(task),
        headers: {
          'content-type': 'application/json',
        },
      }).then((response) => {
        if (response.status != 200) {
          reject('Request did not fetch tasks succesfully');
        } else {
          response.json().then((json) => resolve(task));
        }
      });
    });
  }
}
